/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.119 Revision 1.174
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.119 2007/05/12 11:45:51 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.174 2012/06/05 02:07:44 dirtyepic Exp $
4# 4
5# @ECLASS: flag-o-matic.eclass
6# @MAINTAINER:
5# Maintainer: toolchain@gentoo.org 7# toolchain@gentoo.org
8# @BLURB: common functions to manipulate and query toolchain flags
9# @DESCRIPTION:
10# This eclass contains a suite of functions to help developers sanely
11# and safely manage toolchain flags in their builds.
6 12
7# need access to emktemp() 13if [[ ${___ECLASS_ONCE_FLAG_O_MATIC} != "recur -_+^+_- spank" ]] ; then
14___ECLASS_ONCE_FLAG_O_MATIC="recur -_+^+_- spank"
15
8inherit eutils toolchain-funcs multilib 16inherit eutils toolchain-funcs multilib
9 17
10# 18# Return all the flag variables that our high level funcs operate on.
11#### filter-flags <flags> #### 19all-flag-vars() {
12# Remove particular flags from C[XX]FLAGS 20 echo {C,CPP,CXX,CCAS,F,FC,LD}FLAGS
13# Matches only complete flags 21}
14#
15#### append-flags <flags> ####
16# Add extra flags to your current C[XX]FLAGS
17#
18#### replace-flags <orig.flag> <new.flag> ###
19# Replace a flag by another one
20#
21#### replace-cpu-flags <old.cpus> <new.cpu> ###
22# Replace march/mcpu flags that specify <old.cpus>
23# with flags that specify <new.cpu>
24#
25#### is-flag[q] <flag> ####
26# Returns "true" if flag is set in C[XX]FLAGS
27# Matches only complete a flag
28# q version sets return code but doesn't echo
29#
30#### is-ldflag[q] <flag> ####
31# Returns "true" if flag is set in LDFLAGS
32# Matches only complete a flag
33# q version sets return code but doesn't echo
34#
35#### strip-flags ####
36# Strip C[XX]FLAGS of everything except known
37# good options.
38#
39#### strip-unsupported-flags ####
40# Strip C[XX]FLAGS of any flags not supported by
41# installed version of gcc
42#
43#### get-flag <flag> ####
44# Find and echo the value for a particular flag
45#
46#### replace-sparc64-flags ####
47# Sets mcpu to v8 and uses the original value
48# as mtune if none specified.
49#
50#### filter-mfpmath <math types> ####
51# Remove specified math types from the fpmath specification
52# If the user has -mfpmath=sse,386, running `filter-mfpmath sse`
53# will leave the user with -mfpmath=386
54#
55#### append-ldflags ####
56# Add extra flags to your current LDFLAGS
57#
58#### filter-ldflags <flags> ####
59# Remove particular flags from LDFLAGS
60# Matches only complete flags
61#
62#### bindnow-flags ####
63# Returns the flags to enable "now" binding in the current selected linker.
64#
65################ DEPRECATED functions ################
66# The following are still present to avoid breaking existing
67# code more than necessary; however they are deprecated. Please
68# use gcc-specs-* from toolchain-funcs.eclass instead, if you
69# need to know which hardened techs are active in the compiler.
70# See bug #100974
71#
72#### has_hardened ####
73# Returns true if the compiler has 'Hardened' in its version string,
74# (note; switched-spec vanilla compilers satisfy this condition) or
75# the specs file name contains 'hardened'.
76#
77#### has_pie ####
78# Returns true if the compiler by default or with current CFLAGS
79# builds position-independent code.
80#
81#### has_pic ####
82# Returns true if the compiler by default or with current CFLAGS
83# builds position-independent code.
84#
85#### has_ssp_all ####
86# Returns true if the compiler by default or with current CFLAGS
87# generates stack smash protections for all functions
88#
89#### has_ssp ####
90# Returns true if the compiler by default or with current CFLAGS
91# generates stack smash protections for most vulnerable functions
92#
93 22
94# C[XX]FLAGS that we allow in strip-flags 23# {C,CXX,F,FC}FLAGS that we allow in strip-flags
95# Note: shell globs and character lists are allowed 24# Note: shell globs and character lists are allowed
96setup-allowed-flags() { 25setup-allowed-flags() {
97 if [[ -z ${ALLOWED_FLAGS} ]] ; then
98 export ALLOWED_FLAGS="-pipe" 26 ALLOWED_FLAGS="-pipe"
99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune" 27 ALLOWED_FLAGS+=" -O -O1 -O2 -Os -mcpu -march -mtune"
100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all" 28 ALLOWED_FLAGS+=" -fstack-protector -fstack-protector-all"
101 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking" 29 ALLOWED_FLAGS+=" -fbounds-checking -fno-strict-overflow"
102 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time" 30 ALLOWED_FLAGS+=" -fno-PIE -fno-pie -fno-unit-at-a-time"
103 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+" 31 ALLOWED_FLAGS+=" -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
104 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident" 32 ALLOWED_FLAGS+=" -fno-ident -fpermissive"
105 fi 33 ALLOWED_FLAGS+=" -W* -w"
34
106 # allow a bunch of flags that negate features / control ABI 35 # allow a bunch of flags that negate features / control ABI
107 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \ 36 ALLOWED_FLAGS+=" -fno-stack-protector -fno-stack-protector-all \
108 -fno-strict-aliasing -fno-bounds-checking" 37 -fno-strict-aliasing -fno-bounds-checking -fstrict-overflow \
38 -fno-omit-frame-pointer"
109 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \ 39 ALLOWED_FLAGS+=" -mregparm -mno-app-regs -mapp-regs -mno-mmx -mno-sse \
110 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \ 40 -mno-sse2 -mno-sse3 -mno-ssse3 -mno-sse4 -mno-sse4.1 -mno-sse4.2 \
41 -mno-avx -mno-aes -mno-pclmul -mno-sse4a -mno-3dnow -mno-popcnt \
111 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \ 42 -mno-abm -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 -mplt \
112 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \ 43 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
113 -mieee -mieee-with-inexact -mschedule \ 44 -mieee -mieee-with-inexact -mschedule -mfloat-gprs -mspe -mno-spe \
114 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \ 45 -mtls-direct-seg-refs -mno-tls-direct-seg-refs -mflat -mno-flat \
115 -mflat -mno-flat -mno-faster-structs -mfaster-structs \ 46 -mno-faster-structs -mfaster-structs -m32 -m64 -mx32 -mabi \
116 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \ 47 -mlittle-endian -mbig-endian -EL -EB -fPIC -mlive-g0 -mcmodel \
117 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \ 48 -mstack-bias -mno-stack-bias -msecure-plt -m*-toc -mfloat-abi=* \
118 -msecure-plt -D*" 49 -D* -U*"
119 50
120 # C[XX]FLAGS that we are think is ok, but needs testing 51 # 4.5
121 # NOTE: currently -Os have issues with gcc3 and K6* arch's 52 ALLOWED_FLAGS+=" -mno-fma4 -mno-movbe -mno-xop -mno-lwp"
122 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks" 53 # 4.6
54 ALLOWED_FLAGS+=" -mno-fsgsbase -mno-rdrnd -mno-f16c -mno-bmi -mno-tbm"
55
56 export ALLOWED_FLAGS
123 return 0 57 return 0
124} 58}
125 59
126# inverted filters for hardened compiler. This is trying to unpick 60# inverted filters for hardened compiler. This is trying to unpick
127# the hardened compiler defaults. 61# the hardened compiler defaults.
135 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie) 69 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
136 gcc-specs-pie || continue 70 gcc-specs-pie || continue
137 is-flagq -nopie || append-flags -nopie;; 71 is-flagq -nopie || append-flags -nopie;;
138 -fstack-protector) 72 -fstack-protector)
139 gcc-specs-ssp || continue 73 gcc-specs-ssp || continue
140 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;; 74 is-flagq -fno-stack-protector || append-flags $(test-flags -fno-stack-protector);;
141 -fstack-protector-all) 75 -fstack-protector-all)
142 gcc-specs-ssp-to-all || continue 76 gcc-specs-ssp-to-all || continue
143 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;; 77 is-flagq -fno-stack-protector-all || append-flags $(test-flags -fno-stack-protector-all);;
78 -fno-strict-overflow)
79 gcc-specs-nostrict || continue
80 is-flagq -fstrict-overflow || append-flags $(test-flags -fstrict-overflow);;
144 esac 81 esac
145 done 82 done
146} 83}
147 84
148# Remove occurrences of strings from variable given in $1 85# Remove occurrences of strings from variable given in $1
149# Strings removed are matched as globs, so for example 86# Strings removed are matched as globs, so for example
150# '-O*' would remove -O1, -O2 etc. 87# '-O*' would remove -O1, -O2 etc.
151_filter-var() { 88_filter-var() {
152 local f x VAR VAL 89 local f x var=$1 new=()
153 declare -a new
154
155 VAR=$1
156 shift 90 shift
157 eval VAL=\${${VAR}} 91
158 for f in ${VAL}; do 92 for f in ${!var} ; do
159 for x in "$@"; do 93 for x in "$@" ; do
160 # Note this should work with globs like -O* 94 # Note this should work with globs like -O*
161 [[ ${f} == ${x} ]] && continue 2 95 [[ ${f} == ${x} ]] && continue 2
162 done 96 done
163 eval new\[\${\#new\[@]}]=\${f} 97 new+=( "${f}" )
164 done 98 done
165 eval export ${VAR}=\${new\[*]} 99 eval export ${var}=\""${new[*]}"\"
166} 100}
167 101
102# @FUNCTION: filter-flags
103# @USAGE: <flags>
104# @DESCRIPTION:
105# Remove particular <flags> from {C,CPP,CXX,CCAS,F,FC,LD}FLAGS. Accepts shell globs.
168filter-flags() { 106filter-flags() {
169 _filter-hardened "$@" 107 _filter-hardened "$@"
108 local v
109 for v in $(all-flag-vars) ; do
170 _filter-var CFLAGS "$@" 110 _filter-var ${v} "$@"
171 _filter-var CPPFLAGS "$@" 111 done
172 _filter-var CXXFLAGS "$@"
173 return 0 112 return 0
174} 113}
175 114
115# @FUNCTION: filter-lfs-flags
116# @DESCRIPTION:
117# Remove flags that enable Large File Support.
176filter-lfs-flags() { 118filter-lfs-flags() {
177 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments" 119 [[ $# -ne 0 ]] && die "filter-lfs-flags takes no arguments"
120 # http://www.gnu.org/s/libc/manual/html_node/Feature-Test-Macros.html
121 # _LARGEFILE_SOURCE: enable support for new LFS funcs (ftello/etc...)
122 # _LARGEFILE64_SOURCE: enable support for 64bit variants (off64_t/fseeko64/etc...)
123 # _FILE_OFFSET_BITS: default to 64bit variants (off_t is defined as off64_t)
178 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 124 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
179} 125}
180 126
127# @FUNCTION: filter-ldflags
128# @USAGE: <flags>
129# @DESCRIPTION:
130# Remove particular <flags> from LDFLAGS. Accepts shell globs.
131filter-ldflags() {
132 _filter-var LDFLAGS "$@"
133 return 0
134}
135
136# @FUNCTION: append-cppflags
137# @USAGE: <flags>
138# @DESCRIPTION:
139# Add extra <flags> to the current CPPFLAGS.
181append-cppflags() { 140append-cppflags() {
182 [[ -z $* ]] && return 0 141 [[ $# -eq 0 ]] && return 0
183 export CPPFLAGS="${CPPFLAGS} $*" 142 export CPPFLAGS="${CPPFLAGS} $*"
184 return 0 143 return 0
185} 144}
186 145
146# @FUNCTION: append-cflags
147# @USAGE: <flags>
148# @DESCRIPTION:
149# Add extra <flags> to the current CFLAGS.
150append-cflags() {
151 [[ $# -eq 0 ]] && return 0
152 export CFLAGS=$(test-flags-CC ${CFLAGS} "$@")
153 return 0
154}
155
156# @FUNCTION: append-cxxflags
157# @USAGE: <flags>
158# @DESCRIPTION:
159# Add extra <flags> to the current CXXFLAGS.
160append-cxxflags() {
161 [[ $# -eq 0 ]] && return 0
162 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS} "$@")
163 return 0
164}
165
166# @FUNCTION: append-fflags
167# @USAGE: <flags>
168# @DESCRIPTION:
169# Add extra <flags> to the current {F,FC}FLAGS.
170append-fflags() {
171 [[ $# -eq 0 ]] && return 0
172 export FFLAGS=$(test-flags-F77 ${FFLAGS} "$@")
173 export FCFLAGS=$(test-flags-FC ${FCFLAGS} "$@")
174 return 0
175}
176
177# @FUNCTION: append-lfs-flags
178# @DESCRIPTION:
179# Add flags that enable Large File Support.
187append-lfs-flags() { 180append-lfs-flags() {
188 [[ -n $@ ]] && die "append-lfs-flags takes no arguments" 181 [[ $# -ne 0 ]] && die "append-lfs-flags takes no arguments"
182 # see comments in filter-lfs-flags func for meaning of these
189 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 183 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
190} 184}
191 185
186# @FUNCTION: append-ldflags
187# @USAGE: <flags>
188# @DESCRIPTION:
189# Add extra <flags> to the current LDFLAGS.
190append-ldflags() {
191 [[ $# -eq 0 ]] && return 0
192 local flag
193 for flag in "$@"; do
194 [[ ${flag} == -l* ]] && \
195 ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS"
196 done
197
198 export LDFLAGS="${LDFLAGS} $*"
199 return 0
200}
201
202# @FUNCTION: append-flags
203# @USAGE: <flags>
204# @DESCRIPTION:
205# Add extra <flags> to your current {C,CXX,F,FC}FLAGS.
192append-flags() { 206append-flags() {
193 [[ -z $* ]] && return 0 207 [[ $# -eq 0 ]] && return 0
194 export CFLAGS="${CFLAGS} $*" 208 case " $* " in
195 export CXXFLAGS="${CXXFLAGS} $*" 209 *' '-[DIU]*) eqawarn 'please use append-cppflags for preprocessor flags' ;;
210 *' '-L*|\
211 *' '-Wl,*) eqawarn 'please use append-ldflags for linker flags' ;;
212 esac
213 append-cflags "$@"
214 append-cxxflags "$@"
215 append-fflags "$@"
196 return 0 216 return 0
197} 217}
198 218
219# @FUNCTION: replace-flags
220# @USAGE: <old> <new>
221# @DESCRIPTION:
222# Replace the <old> flag with <new>. Accepts shell globs for <old>.
199replace-flags() { 223replace-flags() {
200 [[ $# != 2 ]] \
201 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \ 224 [[ $# != 2 ]] && die "Usage: replace-flags <old flag> <new flag>"
202 && die "replace-flags takes 2 arguments, not $#"
203 225
204 local f fset 226 local f var new
205 declare -a new_CFLAGS new_CXXFLAGS 227 for var in $(all-flag-vars) ; do
206
207 for fset in CFLAGS CXXFLAGS; do
208 # Looping over the flags instead of using a global 228 # Looping over the flags instead of using a global
209 # substitution ensures that we're working with flag atoms. 229 # substitution ensures that we're working with flag atoms.
210 # Otherwise globs like -O* have the potential to wipe out the 230 # Otherwise globs like -O* have the potential to wipe out the
211 # list of flags. 231 # list of flags.
232 new=()
212 for f in ${!fset}; do 233 for f in ${!var} ; do
213 # Note this should work with globs like -O* 234 # Note this should work with globs like -O*
214 [[ ${f} == ${1} ]] && f=${2} 235 [[ ${f} == ${1} ]] && f=${2}
215 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f} 236 new+=( "${f}" )
216 done
217 eval export ${fset}=\${new_${fset}\[*]}
218 done 237 done
238 eval export ${var}=\""${new[*]}"\"
239 done
219 240
220 return 0 241 return 0
221} 242}
222 243
244# @FUNCTION: replace-cpu-flags
245# @USAGE: <old> <new>
246# @DESCRIPTION:
247# Replace cpu flags (like -march/-mcpu/-mtune) that select the <old> cpu
248# with flags that select the <new> cpu. Accepts shell globs for <old>.
223replace-cpu-flags() { 249replace-cpu-flags() {
224 local newcpu="$#" ; newcpu="${!newcpu}" 250 local newcpu="$#" ; newcpu="${!newcpu}"
225 while [ $# -gt 1 ] ; do 251 while [ $# -gt 1 ] ; do
226 # quote to make sure that no globbing is done (particularly on 252 # quote to make sure that no globbing is done (particularly on
227 # ${oldcpu}) prior to calling replace-flags 253 # ${oldcpu}) prior to calling replace-flags
239 [[ ${x} == $2 ]] && return 0 265 [[ ${x} == $2 ]] && return 0
240 done 266 done
241 return 1 267 return 1
242} 268}
243 269
270# @FUNCTION: is-flagq
271# @USAGE: <flag>
272# @DESCRIPTION:
273# Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs.
244is-flagq() { 274is-flagq() {
245 [[ -n $2 ]] && die "Usage: is-flag <flag>" 275 [[ -n $2 ]] && die "Usage: is-flag <flag>"
246 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1
247}
248 276
277 local var
278 for var in $(all-flag-vars) ; do
279 _is_flagq ${var} "$1" && return 0
280 done
281 return 1
282}
283
284# @FUNCTION: is-flag
285# @USAGE: <flag>
286# @DESCRIPTION:
287# Echo's "true" if flag is set in {C,CXX,F,FC}FLAGS. Accepts shell globs.
249is-flag() { 288is-flag() {
250 is-flagq "$@" && echo true 289 is-flagq "$@" && echo true
251} 290}
252 291
292# @FUNCTION: is-ldflagq
293# @USAGE: <flag>
294# @DESCRIPTION:
295# Returns shell true if <flag> is in LDFLAGS, else returns shell false. Accepts shell globs.
253is-ldflagq() { 296is-ldflagq() {
254 [[ -n $2 ]] && die "Usage: is-ldflag <flag>" 297 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
255 _is_flagq LDFLAGS $1 298 _is_flagq LDFLAGS $1
256} 299}
257 300
301# @FUNCTION: is-ldflag
302# @USAGE: <flag>
303# @DESCRIPTION:
304# Echo's "true" if flag is set in LDFLAGS. Accepts shell globs.
258is-ldflag() { 305is-ldflag() {
259 is-ldflagq "$@" && echo true 306 is-ldflagq "$@" && echo true
260} 307}
261 308
309# @FUNCTION: filter-mfpmath
310# @USAGE: <math types>
311# @DESCRIPTION:
312# Remove specified math types from the fpmath flag. For example, if the user
313# has -mfpmath=sse,386, running `filter-mfpmath sse` will leave the user with
314# -mfpmath=386.
262filter-mfpmath() { 315filter-mfpmath() {
263 local orig_mfpmath new_math prune_math 316 local orig_mfpmath new_math prune_math
264 317
265 # save the original -mfpmath flag 318 # save the original -mfpmath flag
266 orig_mfpmath=$(get-flag -mfpmath) 319 orig_mfpmath=$(get-flag -mfpmath)
285 replace-flags ${orig_mfpmath} -mfpmath=${new_math} 338 replace-flags ${orig_mfpmath} -mfpmath=${new_math}
286 fi 339 fi
287 return 0 340 return 0
288} 341}
289 342
343# @FUNCTION: strip-flags
344# @DESCRIPTION:
345# Strip C[XX]FLAGS of everything except known good/safe flags.
290strip-flags() { 346strip-flags() {
291 local x y flag NEW_CFLAGS NEW_CXXFLAGS 347 local x y var
292 348
293 setup-allowed-flags 349 setup-allowed-flags
294 350
295 local NEW_CFLAGS=""
296 local NEW_CXXFLAGS=""
297
298 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
299 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
300 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
301 fi
302
303 set -f # disable pathname expansion 351 set -f # disable pathname expansion
304 352
305 for x in ${CFLAGS}; do 353 for var in $(all-flag-vars) ; do
354 local new=()
355
356 for x in ${!var} ; do
357 local flag=${x%%=*}
306 for y in ${ALLOWED_FLAGS}; do 358 for y in ${ALLOWED_FLAGS} ; do
307 flag=${x%%=*}
308 if [ "${flag%%${y}}" = "" ] ; then 359 if [[ -z ${flag%%${y}} ]] ; then
309 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 360 new+=( "${x}" )
310 break 361 break
311 fi 362 fi
312 done 363 done
313 done 364 done
314 365
315 for x in ${CXXFLAGS}; do
316 for y in ${ALLOWED_FLAGS}; do
317 flag=${x%%=*}
318 if [ "${flag%%${y}}" = "" ] ; then
319 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
320 break
321 fi
322 done
323 done
324
325 # In case we filtered out all optimization flags fallback to -O2 366 # In case we filtered out all optimization flags fallback to -O2
326 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then 367 if _is_flagq ${var} "-O*" && ! _is_flagq new "-O*" ; then
327 NEW_CFLAGS="${NEW_CFLAGS} -O2" 368 new+=( -O2 )
328 fi 369 fi
329 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then 370
330 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2" 371 eval export ${var}=\""${new[*]}"\"
331 fi 372 done
332 373
333 set +f # re-enable pathname expansion 374 set +f # re-enable pathname expansion
334 375
335 export CFLAGS="${NEW_CFLAGS}"
336 export CXXFLAGS="${NEW_CXXFLAGS}"
337 return 0 376 return 0
338} 377}
339 378
340test-flag-PROG() { 379test-flag-PROG() {
341 local comp=$1 380 local comp=$1
342 local flags="$2" 381 local flag=$2
343 382
344 [[ -z ${comp} || -z ${flags} ]] && \ 383 [[ -z ${comp} || -z ${flag} ]] && return 1
345 return 1
346 384
385 # use -c so we can test the assembler as well
347 local PROG=$(tc-get${comp}) 386 local PROG=$(tc-get${comp})
348 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \ 387 ${PROG} "${flag}" -c -o /dev/null -xc /dev/null \
349 > /dev/null 2>&1 388 > /dev/null 2>&1
350} 389}
351 390
352# Returns true if C compiler support given flag 391# @FUNCTION: test-flag-CC
392# @USAGE: <flag>
393# @DESCRIPTION:
394# Returns shell true if <flag> is supported by the C compiler, else returns shell false.
353test-flag-CC() { test-flag-PROG "CC" "$1"; } 395test-flag-CC() { test-flag-PROG "CC" "$1"; }
354 396
355# Returns true if C++ compiler support given flag 397# @FUNCTION: test-flag-CXX
398# @USAGE: <flag>
399# @DESCRIPTION:
400# Returns shell true if <flag> is supported by the C++ compiler, else returns shell false.
356test-flag-CXX() { test-flag-PROG "CXX" "$1"; } 401test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
402
403# @FUNCTION: test-flag-F77
404# @USAGE: <flag>
405# @DESCRIPTION:
406# Returns shell true if <flag> is supported by the Fortran 77 compiler, else returns shell false.
407test-flag-F77() { test-flag-PROG "F77" "$1"; }
408
409# @FUNCTION: test-flag-FC
410# @USAGE: <flag>
411# @DESCRIPTION:
412# Returns shell true if <flag> is supported by the Fortran 90 compiler, else returns shell false.
413test-flag-FC() { test-flag-PROG "FC" "$1"; }
357 414
358test-flags-PROG() { 415test-flags-PROG() {
359 local comp=$1 416 local comp=$1
360 local flags 417 local flags
361 local x 418 local x
362 419
363 shift 420 shift
364 421
365 [[ -z ${comp} ]] && return 1 422 [[ -z ${comp} ]] && return 1
366 423
367 x=""
368 for x in "$@" ; do 424 for x in "$@" ; do
369 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}" 425 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
370 done 426 done
371 427
372 echo "${flags}" 428 echo "${flags}"
373 429
374 # Just bail if we dont have any flags 430 # Just bail if we dont have any flags
375 [[ -n ${flags} ]] 431 [[ -n ${flags} ]]
376} 432}
377 433
378# Returns (echo's) the given flags supported by the C compiler 434# @FUNCTION: test-flags-CC
435# @USAGE: <flags>
436# @DESCRIPTION:
437# Returns shell true if <flags> are supported by the C compiler, else returns shell false.
379test-flags-CC() { test-flags-PROG "CC" "$@"; } 438test-flags-CC() { test-flags-PROG "CC" "$@"; }
380 439
381# Returns (echo's) the given flags supported by the C++ compiler 440# @FUNCTION: test-flags-CXX
441# @USAGE: <flags>
442# @DESCRIPTION:
443# Returns shell true if <flags> are supported by the C++ compiler, else returns shell false.
382test-flags-CXX() { test-flags-PROG "CXX" "$@"; } 444test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
383 445
446# @FUNCTION: test-flags-F77
447# @USAGE: <flags>
448# @DESCRIPTION:
449# Returns shell true if <flags> are supported by the Fortran 77 compiler, else returns shell false.
450test-flags-F77() { test-flags-PROG "F77" "$@"; }
451
452# @FUNCTION: test-flags-FC
453# @USAGE: <flags>
454# @DESCRIPTION:
455# Returns shell true if <flags> are supported by the Fortran 90 compiler, else returns shell false.
456test-flags-FC() { test-flags-PROG "FC" "$@"; }
457
458# @FUNCTION: test-flags
459# @USAGE: <flags>
460# @DESCRIPTION:
384# Short-hand that should hopefully work for both C and C++ compiler, but 461# Short-hand that should hopefully work for both C and C++ compiler, but
385# its really only present due to the append-flags() abomination. 462# its really only present due to the append-flags() abomination.
386test-flags() { test-flags-CC "$@"; } 463test-flags() { test-flags-CC "$@"; }
387 464
388# Depriciated, use test-flags() 465# @FUNCTION: test_version_info
389test_flag() { 466# @USAGE: <version>
390 ewarn "test_flag: deprecated, please use test-flags()!" >&2 467# @DESCRIPTION:
391 468# Returns shell true if the current C compiler version matches <version>, else returns shell false.
392 test-flags-CC "$@" 469# Accepts shell globs.
393}
394
395test_version_info() { 470test_version_info() {
396 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then 471 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
397 return 0 472 return 0
398 else 473 else
399 return 1 474 return 1
400 fi 475 fi
401} 476}
402 477
478# @FUNCTION: strip-unsupported-flags
479# @DESCRIPTION:
480# Strip {C,CXX,F,FC}FLAGS of any flags not supported by the active toolchain.
403strip-unsupported-flags() { 481strip-unsupported-flags() {
404 export CFLAGS=$(test-flags-CC ${CFLAGS}) 482 export CFLAGS=$(test-flags-CC ${CFLAGS})
405 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS}) 483 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
484 export FFLAGS=$(test-flags-F77 ${FFLAGS})
485 export FCFLAGS=$(test-flags-FC ${FCFLAGS})
406} 486}
407 487
488# @FUNCTION: get-flag
489# @USAGE: <flag>
490# @DESCRIPTION:
491# Find and echo the value for a particular flag. Accepts shell globs.
408get-flag() { 492get-flag() {
409 local f findflag="$1" 493 local f var findflag="$1"
410 494
411 # this code looks a little flaky but seems to work for 495 # this code looks a little flaky but seems to work for
412 # everything we want ... 496 # everything we want ...
413 # for example, if CFLAGS="-march=i686": 497 # for example, if CFLAGS="-march=i686":
414 # `get-flag -march` == "-march=i686" 498 # `get-flag -march` == "-march=i686"
415 # `get-flag march` == "i686" 499 # `get-flag march` == "i686"
416 for f in ${CFLAGS} ${CXXFLAGS} ; do 500 for var in $(all-flag-vars) ; do
501 for f in ${!var} ; do
417 if [ "${f/${findflag}}" != "${f}" ] ; then 502 if [ "${f/${findflag}}" != "${f}" ] ; then
418 printf "%s\n" "${f/-${findflag}=}" 503 printf "%s\n" "${f/-${findflag}=}"
419 return 0 504 return 0
420 fi 505 fi
506 done
421 done 507 done
422 return 1 508 return 1
423} 509}
424 510
425# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs 511# @FUNCTION: has_m64
426has_hardened() { 512# @DESCRIPTION:
427 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2 513# This doesn't test if the flag is accepted, it tests if the flag actually
428 514# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
429 test_version_info Hardened && return 0 515# return code is 0, else the return code is 1.
430 # The specs file wont exist unless gcc has GCC_SPECS support
431 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
432}
433
434# DEPRECATED - use gcc-specs-pie from toolchain-funcs
435# indicate whether PIC is set
436has_pic() {
437 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
438
439 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
440 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
441 gcc-specs-pie
442}
443
444# DEPRECATED - use gcc-specs-pie from toolchain-funcs
445# indicate whether PIE is set
446has_pie() {
447 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
448
449 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
450 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
451 gcc-specs-pie
452}
453
454# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
455# indicate whether code for SSP is being generated for all functions
456has_ssp_all() {
457 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
458
459 # note; this matches only -fstack-protector-all
460 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
461 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
462 gcc-specs-ssp-all
463}
464
465# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
466# indicate whether code for SSP is being generated
467has_ssp() {
468 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
469
470 # note; this matches both -fstack-protector and -fstack-protector-all
471 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
472 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
473 gcc-specs-ssp
474}
475
476has_m64() { 516has_m64() {
517 eqawarn "${FUNCNAME}: don't use this anymore"
518
477 # this doesnt test if the flag is accepted, it tests if the flag 519 # this doesnt test if the flag is accepted, it tests if the flag
478 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 520 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
479 # please dont replace this function with test_flag in some future 521 # please dont replace this function with test_flag in some future
480 # clean-up! 522 # clean-up!
481 523
488 [[ ${ret} != 1 ]] && return 0 530 [[ ${ret} != 1 ]] && return 0
489 return 1 531 return 1
490} 532}
491 533
492has_m32() { 534has_m32() {
493 # this doesnt test if the flag is accepted, it tests if the flag 535 die "${FUNCNAME}: don't use this anymore"
494 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
495 # please dont replace this function with test_flag in some future
496 # clean-up!
497
498 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
499
500 local temp=$(emktemp)
501 echo "int main() { return(0); }" > "${temp}".c
502 MY_CC=$(tc-getCC)
503 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
504 local ret=$?
505 rm -f "${temp}".c
506 [[ ${ret} != 1 ]] && return 0
507 return 1
508} 536}
509 537
538# @FUNCTION: replace-sparc64-flags
539# @DESCRIPTION:
540# Sets mcpu to v8 and uses the original value as mtune if none specified.
510replace-sparc64-flags() { 541replace-sparc64-flags() {
511 local SPARC64_CPUS="ultrasparc3 ultrasparc v9" 542 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
512 543
513 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then 544 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
514 for x in ${SPARC64_CPUS}; do 545 for x in ${SPARC64_CPUS}; do
531 fi 562 fi
532 563
533 export CFLAGS CXXFLAGS 564 export CFLAGS CXXFLAGS
534} 565}
535 566
567# @FUNCTION: append-libs
568# @USAGE: <libs>
569# @DESCRIPTION:
570# Add extra <libs> to the current LIBS.
536append-ldflags() { 571append-libs() {
537 [[ -z $* ]] && return 0 572 [[ $# -eq 0 ]] && return 0
538 export LDFLAGS="${LDFLAGS} $*" 573 local flag
539 return 0 574 for flag in "$@"; do
540} 575 [[ ${flag} == -l* ]] && flag=${flag#-l}
576 export LIBS="${LIBS} -l${flag}"
577 done
541 578
542# Remove flags from LDFLAGS - it's up to the ebuild to filter
543# CFLAGS and CXXFLAGS via filter-flags if they need to.
544filter-ldflags() {
545 _filter-var LDFLAGS "$@"
546 return 0 579 return 0
547} 580}
548 581
582# @FUNCTION: raw-ldflags
583# @USAGE: [flags]
584# @DESCRIPTION:
549# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results 585# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
550# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed 586# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
551# to gcc where it needs the '-Wl,'. 587# to gcc where it needs the '-Wl,'.
588#
589# If no flags are specified, then default to ${LDFLAGS}.
552raw-ldflags() { 590raw-ldflags() {
553 local x input="$@" 591 local x input="$@"
554 [[ -z ${input} ]] && input=${LDFLAGS} 592 [[ -z ${input} ]] && input=${LDFLAGS}
555 set -- 593 set --
556 for x in ${input} ; do 594 for x in ${input} ; do
558 set -- "$@" ${x//,/ } 596 set -- "$@" ${x//,/ }
559 done 597 done
560 echo "$@" 598 echo "$@"
561} 599}
562 600
563# Gets the flags needed for "NOW" binding 601# @FUNCTION: no-as-needed
564bindnow-flags() { 602# @RETURN: Flag to disable asneeded behavior for use with append-ldflags.
603no-as-needed() {
565 case $($(tc-getLD) -v 2>&1 </dev/null) in 604 case $($(tc-getLD) -v 2>&1 </dev/null) in
566 *GNU* | *'with BFD'*) # GNU ld 605 *GNU*) # GNU ld
567 echo "-Wl,-z,now" ;; 606 echo "-Wl,--no-as-needed" ;;
568 *Apple*) # Darwin ld
569 echo "-bind_at_load" ;;
570 *)
571 # Some linkers just recognize -V instead of -v
572 case $($(tc-getLD) -V 2>&1 </dev/null) in
573 *Solaris*) # Solaris accept almost the same GNU options
574 echo "-Wl,-z,now" ;;
575 esac
576 ;;
577 esac 607 esac
578} 608}
579 609
580 610fi
581# Some tests for when we screw with things and want to make
582# sure we didn't break anything
583#TESTS() {
584# CFLAGS="-a -b -c=1"
585# CXXFLAGS="-x -y -z=2"
586# LDFLAGS="-l -m -n=3"
587#
588# die() { exit 1; }
589# (is-flag 1 2 3) && die
590# (is-ldflag 1 2 3) && die
591#
592# is-flagq -l && die
593# is-ldflagq -a && die
594# is-flagq -a || die
595# is-flagq -x || die
596# is-ldflagq -n=* || die
597# is-ldflagq -n && die
598#
599# strip-unsupported-flags
600# [[ ${CFLAGS} == "-c=1" ]] || die
601# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
602#
603# echo "All tests pass"
604#}
605#TESTS

Legend:
Removed from v.1.119  
changed lines
  Added in v.1.174

  ViewVC Help
Powered by ViewVC 1.1.20